//the amazing box by tglad
//#parameter Iterations 13 16 1
//#parameter Scale 2.5 3.5 1.5
//#parameter MinRad 0.25 1.0 0.0

float DistanceEstimation(float3 a_Position, __constant float* a_Parameters)
{
	float4 z = (float4)(a_Position,1.0);
	float4 c = z;
	float4 scale = (float4)(-a_Parameters[1], -a_Parameters[1], -a_Parameters[1], a_Parameters[1]); 

	for (float i = 0; i < a_Parameters[0]; i += 1.0f)
	{
		z.xyz=min(max(z.xyz,-1.0),1.0)*2.0-z.xyz;
		z*=scale/min(max(dot(z.xyz,z.xyz),a_Parameters[2]),1.0);
		z+=c;
	}

	return (length(z.xyz)-a_Parameters[1]*a_Parameters[1]*0.666)/z.w;
}